/*
 * Problem    : crisis
 * Author     : Daniel Neiter
 * Language   : C++
 * Compiler   : MS Visual C++ 2008 Express Edition
 * Algorithm  : Dynamic programming 
 * Complexity : O(N^2) 
 */

#include <cstdio>
#include <fstream>

using namespace std;

const char *infile="crisis.dat";
const char *outfile="crisis.sol";

const int maxN=50000;

int ur[maxN];
int lr[maxN];
long long got[maxN];

int main() {
     int i,j;
     int n,s;
     long long bestur;
     FILE *ifs=fopen(infile,"r");
     ofstream ofs(outfile);

     fscanf(ifs,"%d%d",&n,&s);
     for(i=0;i<n;i++)
          fscanf(ifs,"%d%d",&ur[i],&lr[i]);
     for(i=0;i<n;i++) {
          bestur=lr[i];         // corresponds to no transaction
          for(j=i-1;j>=0;j--) {
               got[i]=max(got[i],got[j]%bestur + (got[j]/bestur)*lr[i]);
               if(bestur>ur[j])bestur=ur[j];
          }
          got[i]=max(got[i],s%bestur + (s/bestur)*lr[i]);
     }
     ofs<<got[n-1]<<endl;

     fclose(ifs);
     return 0;
}
