/*
 * Problem    : crisis
 * Author     : Daniel Neiter
 * Language   : C++
 * Compiler   : MS Visual C++ 2008 Express Edition
 * Algorithm  : Greedy algorithm
 * Complexity : O(N) 
 */

#include <cstdio>
#include <fstream>
#include <algorithm>

using namespace std;

const char *infile="crisis.dat";
const char *outfile="crisis.sol";

const int maxN=50000;

int lr[maxN];
int ur[maxN];
bool sell[maxN];
int f[maxN]; // next profittable upper rate

int main() {
     int i;
     int n,s;
     long long olimp,galact;
     FILE *ifs=fopen(infile,"r");
     ofstream ofs(outfile);

     fscanf(ifs,"%d%d",&n,&s);
     for(i=0;i<n;i++) 
          fscanf(ifs,"%d%d",&ur[i],&lr[i]);
     sell[n-1]=true;
     f[n-1]=lr[n-1];
     for(i=n-2;i>=0;i--) {
          if(f[i+1]<lr[i]) { // new selling point
               sell[i]=true;
               f[i]=lr[i];
          }
          else {
               sell[i]=false;
               f[i]=min(f[i+1],ur[i]);
          }
     }
     olimp=s;
     galact=0;
     for(i=0;i<n;i++) 
          if(sell[i]) {
               olimp+=galact*lr[i];
               galact=0;
          }
          else if(f[i]==ur[i]) {
               galact+=olimp/ur[i];
               olimp%=ur[i];
          }
     
     ofs<<olimp<<endl;

     fclose(ifs);
     return 0;
}
